/* JSBlock.m created by Administrator on Sat 20-Jun-1998 */

#import "JSBlock.h"

@implementation JSBlock




-(NSArray *) keys
{
    return [NSArray arrayWithObjects: @"language", @"string", @"file", @"framework", @"disabled", nil];
}








-(id) initWithName:(NSString *) aName associations:(NSDictionary *) someAssociations template:(WOElement *) anElement
{
    NSException	*exc;
    NSArray	*kArray;



    
    kArray = [someAssociations allKeys];

    if (([kArray containsObject: @"string"] ^ [kArray containsObject: @"file"]) == NO) {
        exc = [NSException exceptionWithName: NSInvalidArgumentException
		reason: @"JSBlock: One principal parameter must be set: file|string"
		userInfo: nil];
        [exc raise];
    } 

    //
    // OK, get values ...
    //

    _langAssoc		= [[someAssociations objectForKey: @"language"] retain];
    _stringAssoc	= [[someAssociations objectForKey: @"string"] retain];
    _fileAssoc       	= [[someAssociations objectForKey: @"file"] retain];
    _framewAssoc       	= [[someAssociations objectForKey: @"framework"] retain];
    _disabledAssoc	= [[someAssociations objectForKey: @"disabled"] retain];

    _subTemplate	= [anElement retain];

    [super initWithName: aName associations: someAssociations template:anElement];
    return self;

}







-(void) appendToResponse:(WOResponse *) aResponse inContext:(WOContext *) aContext
{
    NSString		*aPath;
    NSString		*aContent;
    NSException		*exc;

    BOOL		render = YES;


    
    if (_disabledAssoc && [[_disabledAssoc value] boolValue] == YES) {
        render = NO;
    } else if ([[aContext request] isFromClientComponent] == YES) {
        render = NO;
    }

    if (render == YES) {

        if (_langAssoc) {
            [aResponse appendContentString: @"<script language=\""];
            [aResponse appendContentHTMLAttributeValue: [_langAssoc value]];
            [aResponse appendContentString: @"\">\n"];
        } else {
            [aResponse appendContentString: @"<script>\n"];
        }

        if (_stringAssoc) {
            [aResponse appendContentString: [_stringAssoc value]];
        } else {

            aPath = [[WOApp resourceManager]
		pathForResourceNamed: [_fileAssoc value]
           	inFramework: [_framewAssoc value]
            ];
            
            if (aPath) {
                aContent = [NSString stringWithContentsOfFile: aPath];
                [aResponse appendContentString: aContent];
            } else {
                exc = [NSException exceptionWithName: NSInvalidArgumentException
			reason: @"Script file not found!"
			userInfo: nil];
                [exc raise];
            }
        }

        if (_subTemplate) {
            [_subTemplate appendToResponse: aResponse inContext: aContext];
        }

        [aResponse appendContentString: @"</script>\n"];

    }
}









-(void) dealloc
{
    [_langAssoc release];
    [_stringAssoc release];
    [_fileAssoc release];
    [_framewAssoc release];
    [_disabledAssoc release];


    [_subTemplate release];
    [super dealloc];
}


@end
