/* JSOpenWindow.m created by Administrator on Thu 04-Jun-1998 */

#import "JSHyperlink.h"



@implementation JSHyperlink




-(NSArray *) keys
{
    return [NSArray arrayWithObjects: @"href", @"pageName", @"action", @"string", @"disabled", @"target", @"featureString", nil];
}








-(id) initWithName:(NSString *) aName associations:(NSDictionary *) someAssociations template:(WOElement *) anElement
{
    NSException	*exc;
    NSArray	*kArray;
    int		c = 0;
    
    kArray = [someAssociations allKeys];

    c += ([kArray containsObject: @"href"] == YES	? 1 : 0);
    c += ([kArray containsObject: @"pageName"] == YES	? 1 : 0);
    c += ([kArray containsObject: @"action"] == YES	? 1 : 0);

    if (c != 1) {
        exc = [NSException exceptionWithName: NSInvalidArgumentException
                                      reason: @"One principal parameter must be set: href|pageName|action"
                                    userInfo: nil];
        [exc raise];
        return nil;
    }

    //
    // OK, get values ...
    //

    _hrefAssoc		= [[someAssociations objectForKey: @"href"] retain];
    _pageAssoc		= [[someAssociations objectForKey: @"pageName"] retain];
    _actionAssoc       	= [[someAssociations objectForKey: @"action"] retain];
    _stringAssoc	= [[someAssociations objectForKey: @"string"] retain];
    _disabledAssoc	= [[someAssociations objectForKey: @"disabled"] retain];
    _targetAssoc	= [[someAssociations objectForKey: @"target"] retain];
    _featAssoc		= [[someAssociations objectForKey: @"featureString"] retain];

    _subTemplate	= [anElement retain];
    
    [super initWithName: aName associations: someAssociations template:anElement];
    return self;

}







-(void) appendToResponse:(WOResponse *) aResponse inContext:(WOContext *) aContext
{
    BOOL		render = YES;



    if (_disabledAssoc && [[_disabledAssoc value] boolValue] == YES) {
        render = NO;
    } else if ([[aContext request] isFromClientComponent] == YES) {
        render = NO;
    }

    if (render == YES) {
        if (_hrefAssoc) {
            [aResponse appendContentString:
                [NSString stringWithFormat: @"<a href=\"javascript:void(open(\'%@\'",
                    [_hrefAssoc value]]];
        } else {
            [aResponse appendContentString:
                [NSString stringWithFormat:@"<a href=\"javascript:void(open(\'%@\'",
                    [aContext url]]];
        }

        if (_targetAssoc) {
            [aResponse appendContentString:
                [NSString stringWithFormat:@", '%@'", [_targetAssoc value]]
            ];
            if (_featAssoc) {
                [aResponse appendContentString:
                    [NSString stringWithFormat:@", '%@'", [_featAssoc value]]
                ];
            }
        }

        [aResponse appendContentString: @"))\">"];

	if (_subTemplate) {
            [_subTemplate appendToResponse: aResponse inContext: aContext];
        }
        if (_stringAssoc) {
            [aResponse appendContentString: [_stringAssoc value]];
        }

        [aResponse appendContentString: @"</a>"];
    }

}







-(WOElement *) invokeActionForRequest:(WORequest *) aRequest inContext:(WOContext *) aContext
{
    if ([[aContext elementID] isEqualToString:[aRequest senderID]]) {
        if (_pageAssoc) {
            return [WOApp pageWithName: [_pageAssoc value]];
        } else if (_actionAssoc) {
                return [_actionAssoc value];
        } else {
            NSLog(@"[JSHyperlink.invokeAction..::]: No action or page was given.");
            return nil;
        }
    } else {
        return [super invokeActionForRequest:aRequest inContext:aContext];
    }
}



-(void) dealloc
{
    [_hrefAssoc release];
    [_pageAssoc release];
    [_actionAssoc release];
    [_stringAssoc release];
    [_disabledAssoc release];
    [_targetAssoc release];
    [_featAssoc release];


    [_subTemplate release];
    [super dealloc];
}

@end
