/* JSWOAction.m created by Administrator on Thu 18-Jun-1998 */

#import "JSWOAction.h"






@implementation JSWOAction




-(NSArray *) keys
{
    return [NSArray arrayWithObjects: @"htmlString", @"pageName", @"action", @"disabled", nil];
}








-(id) initWithName:(NSString *) aName associations:(NSDictionary *) someAssociations template:(WOElement *) anElement
{
    NSException	*exc;
    NSArray	*kArray;

    

    
    kArray = [someAssociations allKeys];

    if (([kArray containsObject: @"pageName"] ^ [kArray containsObject: @"action"]) == NO) {
        exc = [NSException exceptionWithName: NSInvalidArgumentException
                                      reason: @"One principal parameter must be set: pageName|action"
                                    userInfo: nil];
        [exc raise];
    } else if ([kArray containsObject: @"htmlString"] == NO) {
        exc = [NSException exceptionWithName: NSInvalidArgumentException
                                      reason: @"Parameter htmlString is missing!"
                                    userInfo: nil];
        [exc raise];
    }

    //
    // OK, get values ...
    //

    _htmlAssoc		= [[someAssociations objectForKey: @"htmlString"] retain];
    _pageAssoc		= [[someAssociations objectForKey: @"pageName"] retain];
    _actionAssoc       	= [[someAssociations objectForKey: @"action"] retain];
    _disabledAssoc	= [[someAssociations objectForKey: @"disabled"] retain];

    _subTemplate	= [anElement retain];

    [super initWithName: aName associations: someAssociations template:anElement];
    return self;

}







-(void) appendToResponse:(WOResponse *) aResponse inContext:(WOContext *) aContext
{
    BOOL		render = YES;

    if (_disabledAssoc && [[_disabledAssoc value] boolValue] == YES) {
        render = NO;
    } else if ([[aContext request] isFromClientComponent] == YES) {
        render = NO;
    }



    if (render == YES) {
        [aResponse appendContentString: [NSString stringWithFormat: [_htmlAssoc value], [aContext url]]];

        if (_subTemplate) {
            [_subTemplate appendToResponse: aResponse inContext: aContext];
        }
    }
}







-(WOElement *) invokeActionForRequest:(WORequest *) aRequest inContext:(WOContext *) aContext
{
    if ([[aContext elementID] isEqualToString:[aRequest senderID]]) {
        if (_pageAssoc) {
            return [WOApp pageWithName: [_pageAssoc value]];
        } else if (_actionAssoc) {
                return [_actionAssoc value];
        } else {
            NSLog(@"[JSWOAction.invokeAction..::]: No action or page was given.");
            return nil;
        }
    } else {
        return [super invokeActionForRequest:aRequest inContext:aContext];
    }
}






-(void) dealloc
{
    [_pageAssoc release];
    [_actionAssoc release];
    [_disabledAssoc release];


    [_subTemplate release];
    [super dealloc];
}

@end
