/* WOScriptedApplet.m created by chaos on Tue 23-Jun-1998 */

#import "WOScriptedApplet.h"



#define W3_CodeAttribute			@"code"
#define W3_AssociationClassAttribute		@"associationClass"
#define W3_ObjectAttribute			@"object"
#define W3_AltAttribute				@"alt"
#define W3_AlignAttribute			@"align"
#define W3_VSpaceAttribute			@"vspace"
#define W3_HSpaceAttribute			@"hspace"
#define W3_WidthAttribute			@"width"
#define W3_HeightAttribute			@"height"
#define W3_NameAttribute			@"name"
#define W3_CodebaseAttribute			@"codebase"
#define W3_ValueAttribute			@"value"


@implementation WOApplet(WOScriptedApplet)




-(id) initWithName:(NSString *) aName associations:(NSDictionary *) someAssociations contentElements:(NSArray *) someElements
{
    NSMutableDictionary	*dict1;	
    NSMutableArray	*array1;
    WOParam		*aParam;
    BOOL		flag1;
    NSArray		*keys;
    int			i;
    int			cnt;
    NSString		*aString;

    WOAssociation	*anAssoc;

    NSArray	*newRenderingStrings;
    BOOL	msFlag;
    id		anObj;

    NSLog(@"aName: %@", aName);
    NSLog(@"Dict: %@", someAssociations);
    NSLog(@"Array: %@", someElements);

    
    dict1	= [[[NSMutableDictionary alloc] initWithDictionary: someAssociations ] autorelease];
    array1	= [[[NSMutableArray allocWithZone: [self zone]] initWithArray: someElements] autorelease];

    flag1	= NO;    
    msFlag	= NO;    


    [WOComponent _registerObserver: self];
    

    NS_DURING
    if (![someAssociations objectForKey: W3_CodeAttribute]) {
        [NSException raise: NSInvalidArgumentException format: @"%@: no '%@' attribute specified", [self class], W3_CodeAttribute];
    }

    if ([someAssociations objectForKey: @"script"]) {
	anObj = [[someAssociations objectForKey: @"script"] value];

        if ([anObj isKindOfClass: [NSString class]] == YES && ![anObj compare:@"YES"]) {
            msFlag = YES;
        } else if ([anObj isKindOfClass: [NSNumber class]] == YES && [anObj boolValue] == YES) {
            msFlag = YES;
        }
	[dict1 removeObjectForKey:@"script"];
    }

    _archive = [[dict1 objectForKey: @"archive"] retain];
    [dict1 removeObjectForKey: @"archive"];

    _archiveNames = [[dict1 objectForKey: @"archiveNames"] retain];
    [dict1 removeObjectForKey: @"archiveNames"];

    _agcArchive = [[dict1 objectForKey: @"agcArchive"] retain];
    [dict1 removeObjectForKey: @"agcArchive"];

    _agcArchiveNames = [[dict1 objectForKey: @"agcArchiveNames"] retain];
    [dict1 removeObjectForKey: @"agcArchiveNames"];


    NSLog(@"(1)");

    if ([someAssociations objectForKey: W3_AssociationClassAttribute]) {
        [dict1 removeObjectForKey: W3_AssociationClassAttribute];

        aParam = [self	paramWithName: [WOAssociation associationWithValue: @"WOAssociationClass"]
                        value:	[someAssociations objectForKey: W3_AssociationClassAttribute]
                        target: nil
                        key: nil
                        treatNilValueAsWONull: NO];
        [array1 addObject: aParam];

        flag1 = YES;
    } else if ([someAssociations objectForKey: [W3_AssociationClassAttribute lowercaseString]]) {
        [dict1 removeObjectForKey: [W3_AssociationClassAttribute lowercaseString]];

        aParam = [self	paramWithName: [WOAssociation associationWithValue: @"WOAssociationClass"]
                        value:	[someAssociations objectForKey: [W3_AssociationClassAttribute lowercaseString]]
                        target: nil
                        key: nil
                        treatNilValueAsWONull: NO];
        [array1 addObject: aParam];

        flag1 = YES;
    } else {
        flag1 = NO;
    }


    NSLog(@"(2)");

    if (flag1 == YES) {
        keys	= [dict1 allKeys];
        cnt	= [keys count];

        NSLog(@"(3)");
        clientSideAttributes	= [[NSMutableDictionary alloc] init];

        aParam = [self	paramWithName: [WOAssociation associationWithValue: @"WOAssociationElementID"]
                        value:	nil
                        target: self
                        key: @"elementID"
                        treatNilValueAsWONull: NO];
        [array1 addObject: aParam];

        aParam = [self	paramWithName: [WOAssociation associationWithValue: @"WOActionURL"]
                        value:	nil
                        target: self
                        key: @"url"
                        treatNilValueAsWONull: NO];
        [array1 addObject: aParam];

        aParam = [self	paramWithName: [WOAssociation associationWithValue: @"WOAssociationContextID"]
                        value:	nil
                        target: self
                        key: @"contextID"
                        treatNilValueAsWONull: NO];
        [array1 addObject: aParam];

        NSLog(@"(4)");

        for (i = 0; i < cnt; i++) {
            aString = (NSString *)[keys objectAtIndex: i];
            // != 0!!
            if ([aString caseInsensitiveCompare: W3_ObjectAttribute]		&&
                [aString caseInsensitiveCompare: W3_AltAttribute]		&&
                [aString caseInsensitiveCompare: W3_AlignAttribute]		&&
                [aString caseInsensitiveCompare: W3_VSpaceAttribute]		&&
                [aString caseInsensitiveCompare: W3_HSpaceAttribute]		&&
                [aString caseInsensitiveCompare: W3_WidthAttribute]		&&
                [aString caseInsensitiveCompare: W3_HeightAttribute]		&&
                [aString caseInsensitiveCompare: W3_NameAttribute]		&&
                [aString caseInsensitiveCompare: W3_CodebaseAttribute]		&&
                [aString caseInsensitiveCompare: W3_CodeAttribute]) {

                NSLog(@"(4): %@", aString);
                
                anAssoc = [WOAssociation associationWithValue:
                        [NSString stringWithFormat:@"%@.%@", @"WOKey",
                                [aString lowercaseString]]];

                aParam = [self paramWithName:	anAssoc
                        value:			[dict1 objectForKey: aString]
                        target:			nil
                        key:			nil
                        treatNilValueAsWONull: YES];
                [array1 addObject: aParam];
                NSLog(@"(5)");
                [dict1 removeObjectForKey: aParam];

                [clientSideAttributes setObject: anAssoc forKey: [aString lowercaseString]];
		NSLog(@"(6)");
            }
        }
    }
    NS_HANDLER
        [localException raise];
    NS_ENDHANDLER

    NSLog(@"(7)");

    if (flag1 == YES) {
        _snapshots = [[NSMutableDictionary allocWithZone: [self zone]] init];

        NSLog(@"Name: %@", aName);
        NSLog(@"Dict: %@", dict1);
        NSLog(@"Array: %@", array1);

        if (![super initWithName: aName attributeAssociations: dict1 contentElements: array1]) {
            [NSException raise: NSInternalInconsistencyException format:@"%@: Something is wrong ...", [self class]];
        }
	

	if (msFlag == YES) {
            newRenderingStrings = [NSArray arrayWithObject:
                [NSString stringWithFormat:@"%@ mayscript",
                    [renderingStrings lastObject]]];

            [renderingStrings release];
            renderingStrings = [newRenderingStrings retain];
	}
	return self;
    }

    return nil;
}

@end
